unit Bode;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, sysUtils, Messages,
  clipBrd, spin, iniFiles, math, tvcLib_TLB, variants,
  system.UITypes,  System.ImageList,
  jmmUtil, graphe, Main, OscConst, ComCtrls, ImgList, ToolWin;


type
  TvoieOsc = class
       Valeur : VecteurOsc;
       valeurEff,valeurDC : extended;
       procedure Calcul(Nbre : integer);
  end;

  TBodeForm = class(TForm)
    SaveDialog: TSaveDialog;
    Oscillo: TPaintBox;
    PanelValeur: TPanel;
    GroupBox3: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    LabelGain: TLabel;
    LabelPhase: TLabel;
    NumVoieRG: TRadioGroup;
    ToolBar1: TToolBar;
    ImageList1: TImageList;
    EnregistreBtn: TToolButton;
    UndoBtn: TToolButton;
    ResetDataBtn: TToolButton;
    AddDataBtn: TToolButton;
    RegSaveBtn: TToolButton;
    ExitBtn: TToolButton;
    StatusBar: TStatusBar;
    procedure SaveItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EnregistreBtnClick(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure UndoBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RegSaveBtnClick(Sender: TObject);
    procedure ClipSaveBtnClick(Sender: TObject);
    procedure ResetDataBtnClick(Sender: TObject);
    procedure VoieFreqClick(Sender: TObject);
    procedure RegNewFileClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure AddDataBtnClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ExitBtnClick(Sender: TObject);
    procedure GainClick(Sender: TObject);
    procedure PhaseClick(Sender: TObject);
  private
    NbrePointsOsc,NbrePointsPeriode : integer;
    VoieOsc : array[indiceVoie] of TvoieOsc;
    voieRef : integer;
    NonSauve : boolean;
    incX : double;
    Procedure SetBoutonAcq;
  public
    Graphe : Tgraphe;
  protected
  end;

var
  BodeForm: TBodeForm;

implementation

uses voieFreq, tds200dde, voieGainU, voiePhaseU;

{$R *.DFM}

procedure TBodeForm.SaveItemClick(Sender: TObject);
begin
     if SaveDialog.Execute then begin
         Graphe.SaveData(saveDialog.FileName);
         NonSauve := false;
     end;
end;

procedure TBodeForm.FormCreate(Sender: TObject);

Procedure Defaut;
begin with graphe do begin
       avecAxeY := true;
       with voie[voieF] do begin
              Nom := 'f';
              Unite := 'Hz';
              Signif := 'frquence';
              Command := '';
              Active := true;
              Positive := true;
              Mini := 100;
              Maxi := 10000;
              axeLog := true;
              axedB := false;
              LabelVoie := Label1;
        end;
        with voie[voieGain] do begin
              Nom := 'G';
              Unite := '';
              Signif := 'gain';
              Command := '';
              Active := true;
              Positive := true;
              Mini := 0.1;
              Maxi := 10;
              axeLog := false;
              axedB := true;
              LabelVoie := LabelGain;
        end;
       with voie[voiePhase] do begin
              Nom := '';
              if enDegre then Unite := '' else Unite := 'rad';
              Signif := 'phase';
              Command := '';
              Active := true;
              Positive := false;
              Mini := -180;
              Maxi := 180;
              axeLog := false;
              axedB := false;
              LabelVoie := LabelPhase;
        end;
        DerniereVoie := voiePhase;
end end;

procedure LitConfig;
const Titre ='Bode';
var Ini : TiniFile;
begin
      Ini := TiniFile.Create(NomFichierIni);
      ConstanteDlg.NomConstEdit.text := Ini.ReadString('Constante','Nom','');
      ConstanteDlg.UniteConstEdit.text := Ini.ReadString('Constante','Unite','');
      with graphe do begin
      with voie[voieF] do begin
              Maxi := Ini.ReadFloat(Titre,'MaxiF',maxi);
              Mini := Ini.ReadFloat(Titre,'MiniF',mini);
              if mini<=1 then mini := 1;
              if mini>=maxi then maxi := 10*Mini;
              axeLog := Ini.ReadBool(Titre,'LogX',true);
       end;
       with voie[voieGain] do begin
              Maxi := Ini.ReadFloat(Titre,'MaxiGain',maxi);
              Mini := Ini.ReadFloat(Titre,'MiniGain',mini);
              if mini<0 then mini := 0;
              if mini>=maxi then maxi := mini+1;
              Couleur := Ini.ReadInteger(Titre,'CouleurG',couleur);
              axedB := Ini.ReadBool(Titre,'LogY',true);
              if axedB and (mini<1e-5) then mini := 0.01;
       end;
       with voie[voiePhase] do begin
              Couleur := Ini.ReadInteger(Titre,'CouleurP',couleur);
              EnDegre := Ini.ReadBool(Titre,'Degre',true);
              Maxi := Ini.ReadFloat(Titre,'MaxiPhase',maxi);
              Mini := Ini.ReadFloat(Titre,'MiniPhase',mini);
              if mini>=maxi then if enDegre
                then Maxi := Mini+90
                else Maxi := Mini+pi/2;
       end;
       VoieRef := Ini.ReadInteger(Titre,'Ref',1);
       NumVoieRG.ItemIndex := voieRef-1;
       derniereVoie := voiePhase;
       Ini.Free;
end end;

var v : indiceVoie;
    j : integer;
begin
  Graphe := Tgraphe.Create;
  Graphe.Canvas := Oscillo.Canvas;
  for v := voieF to voiePhase do with graphe.voie[v] do begin
      for j := 0 to MaxVecteur do
          incertitude[j] := 0;
  end;
  Defaut;
  LitConfig;
  voieOsc[voieT] := tvoieOsc.create;
  voieOsc[voieGain] := tvoieOsc.create;
  voieOsc[voiePhase] := tvoieOsc.create;
  setBoutonAcq;
end;

procedure TBodeForm.OscilloPaint(Sender: TObject);
begin
     with graphe.voie[voiePhase] do if enDegre
             then begin
                   mini := 90*round(mini/90);
                   maxi := 90*round(maxi/90);
                   if maxi>180 then maxi := 180;
                   if mini<-180 then mini := -180;
                   if maxi=mini then maxi := mini+90;
             end
             else begin
                   mini := pi/2*round(mini/pi*2);
                   maxi := pi/2*round(maxi/pi*2);
                   if maxi>pi then maxi := pi;
                   if mini<-pi then mini := -pi;
                   if maxi=mini then maxi := mini+pi/2;
             end;
     Graphe.DrawG(Oscillo.clientRect)
end;

procedure TBodeForm.UndoBtnClick(Sender: TObject);
begin // Supprimer dernier point 
     with graphe do if NbrePoints>0 then dec(NbrePoints);
     Oscillo.refresh;
     setBoutonAcq;
end;

procedure TBodeForm.FormClose(Sender: TObject;var Action: TCloseAction);
begin
    if (graphe.NbrePoints>0) and
        NonSauve and
       (MessageDlg('Sauvegarde',mtConfirmation,[mbYes,mbNo],0)=idYes)
      then SaveItemClick(sender);
    FormMain.setMode(mNone);
    Action := caFree;
end;

procedure TBodeForm.RegSaveBtnClick(Sender: TObject);
begin
     if ConstanteDlg.showModal=mrOk then begin
        FormDDE.EnvoieDonneesMultimetre(true,true,graphe,
           'Diagramme de Bode avec '+FormMain.identiteScope);
        NonSauve := false;
     end;
end;

procedure TBodeForm.ClipSaveBtnClick(Sender: TObject);
begin
     FormDDE.EnvoieDonneesMultimetre(false,true,graphe,
           'Diagramme de Bode avec '+FormMain.identiteScope);
     NonSauve := false;           
end;

procedure TBodeForm.SetBoutonAcq;
begin with graphe do begin
     EnregistreBtn.enabled := NbrePoints<MaxVecteur;
     UndoBtn.Visible := NbrePoints>0;
     ResetDataBtn.Visible := NbrePoints>0;
     AddDataBtn.Visible := NbrePoints>1;
     RegSaveBtn.Visible := NbrePoints>3;
end end;

procedure TBodeForm.ResetDataBtnClick(Sender: TObject);
begin
     if OK('Suppression des donnes courantes') then begin
        Graphe.NbrePoints := 0;
        Oscillo.refresh;
        setBoutonAcq;
     end;
end;

procedure TBodeForm.VoieFreqClick(Sender: TObject);
begin
     if VoieXDlg=nil then
        Application.CreateForm(TVoieXDlg, VoieXDlg);
     VoieXDlg.voieLue := graphe.voie[voieF];
     if VoieXDlg.ShowModal=mrOK then with graphe.voie[voieF] do begin
        LabelVoie.color := couleur;
        Oscillo.invalidate;
        setBoutonAcq;
     end;   
end;

procedure TBodeForm.EnregistreBtnClick(Sender: TObject);
var deuxVoiesActives : boolean;
    modifGamme : boolean;

procedure LitCourbes;

procedure LitVoieOsc(Avoie : integer);
var mini,maxi : Double;
begin
   statusBar.SimpleText := 'lecture de CH'+intTostr(avoie)+' : attendre';
   FormMain.LitVoie(Avoie,voieOsc[avoie].valeur,voieOsc[voieT].valeur,
      mini,maxi,nbrePointsOsc,incX);
   statusBar.SimpleText := 'lecture de CH'+intTostr(avoie)+' termine';
end;

begin
     Screen.Cursor := crHourGlass;
     setBoutonAcq;
     DeuxVoiesActives := FormMain.active(1) and FormMain.active(2);
     if DeuxVoiesActives
        then begin
           LitVoieOsc(voieA);
           litVoieOsc(voieB)
        end
        else Erreur('Deux voies actives ncessaires pour mesurer gain/phase');
     screen.Cursor := crDefault;
end; // litCourbes

procedure CalculGainPhase;
var i : integer;
    quartPeriode : integer;
    somme,sommeQuartPeriode : extended;
    exposant,mantisse,coeff : extended;
// <v1,v2>=sqrt(v1eff)*sqrt(v2eff)*cos
// <v1,v2 pi/2 >=sqrt(v1eff)*sqrt(v2eff)*sin
begin
           voieOsc[1].calcul(NbrePointsPeriode);
           voieOsc[2].calcul(NbrePointsPeriode);
           Somme := 0;
           for i := 0 to pred(NbrePointsPeriode) do begin
               Somme := Somme+
                    (voieOsc[1].valeur[i]-voieOsc[1].valeurDC)*
                    (voieOsc[2].valeur[i]-voieOsc[2].valeurDC);
           end;
           quartPeriode := NbrePointsPeriode div 4;
           SommeQuartPeriode := 0;
           for i := 0 to pred(NbrePointsPeriode) do
               SommeQuartPeriode := SommeQuartPeriode+
                   (voieOsc[1].valeur[i]-voieOsc[1].valeurDC)*
                   (voieOsc[2].valeur[i+quartPeriode]-voieOsc[2].valeurDC);
           graphe.voie[voiePhase].valeurCourante := atan2(SommeQuartPeriode,Somme);
           if voieRef=1 then graphe.voie[voiePhase].valeurCourante :=
                            -graphe.voie[voiePhase].valeurCourante;
           try
           graphe.voie[voieGain].valeurCourante :=
              voieOsc[3-voieRef].valeurEff/voieOsc[voieRef].valeurEff;
           except
           graphe.voie[voieGain].valeurCourante := Nan;
           end;
           with graphe.voie[voieGain] do if not isNan(valeurCourante) then begin
               if valeurCourante>maxi then begin { 512 }
                  exposant := intMaths(log10(abs(valeurCourante))); { 2 }
                  coeff := power(10,exposant); { 100 }
                  mantisse := int(abs(valeurCourante)/coeff); { 5 }
                  maxi := (mantisse+1)*coeff; { 600 }
                  modifGamme := true;
               end;
               if valeurCourante<mini then begin { 512 }
                  exposant := intMaths(log10(abs(valeurCourante))); { 2 }
                  coeff := power(10,exposant); { 100 }
                  mantisse := int(abs(valeurCourante)/coeff); { 5 }
                  mini := mantisse*coeff; { 600 }
                  modifGamme := true;
               end;
           end;
end;

function LitFrequence : boolean;

Function CherchePeriode : boolean;
var i : integer;
    montant : boolean;
    debut,fin : integer;
    sommeDC,minV,maxV,margeV : double;
begin with voieOsc[voieRef] do begin
   SommeDC := 0;
   minV := 0;
   maxV := 0;
   for i := 0 to pred(NbrePointsOsc) do begin
       SommeDC := SommeDC+valeur[i];
       if valeur[i]<minV then minV := valeur[i];
       if valeur[i]<maxV then maxV := valeur[i];
   end;
   margeV := (maxV-minV)/20; // 1/10 de l'amplitude
   valeurDC := SommeDC/NbrePointsOsc;
   montant := valeur[0]<valeurDC;
   i := 0;
   if montant
     then while (i<NbrePointsOsc) and (valeur[i]<valeurDC) do inc(i)
       { front montant, en-dessus >= }
     else while (i<NbrePointsOsc) and (valeur[i]>valeurDC) do inc(i);
       { front descendant, en-dessous <= }
   if i=0 { pile valeur[0]=valeurDC ! } then montant := valeur[1]>valeurDC;
   debut := i;
   while (i<NbrePointsOsc) and (abs(valeur[i]-valeurDC)<margeV) do inc(i); // hysteresis pour le bruit
   if montant
     then while (i<NbrePointsOsc) and (valeur[i]>=valeurDC) do inc(i)
       { front montant on repasse en-dessous < }
     else while (i<NbrePointsOsc) and (valeur[i]<=valeurDC) do inc(i);
       { front descendant, on repasse au-dessus > }
   while (i<NbrePointsOsc) and (abs(valeur[i]-valeurDC)<margeV) do inc(i); // hysteresis pour le bruit
   if montant
      then while (i<NbrePointsOsc) and (valeur[i]<valeurDC) do inc(i)
        { front montant, en-dessus >= }
      else while (i<NbrePointsOsc) and (valeur[i]>valeurDC) do inc(i);
       { front descendant, en-dessous <= }
   fin := i;
   NbrePointsPeriode := fin-debut;
{$IFDEF Debug}
      append(FormMain.fichierDebug);
      writeln(FormMain.fichierDebug,'Bode : NScreen='+intToStr(NbrePointsOsc));
      writeln(FormMain.fichierDebug,'Bode : debut='+intToStr(debut));
      writeln(FormMain.fichierDebug,'Bode : fin='+intToStr(fin));
      writeln(FormMain.fichierDebug,'Bode : NPeriode='+intToStr(NbrePointsPeriode));
      flush(FormMain.fichierDebug);
      closeFile(FormMain.fichierDebug);
{$ENDIF}
   result := fin<(NbrePointsOsc-(NbrePointsPeriode div 4));
   if not result then begin
         Erreur('Impossible de dterminer la phase : moins de deux priodes');
         exit;
   end;
   result := NbrePointsPeriode>(NbrePointsOsc div 16); // 155 points soit 2,3
   if not result then begin
         Erreur('Impossible de dterminer la phase avec prcision : plus de dix priodes');
         exit;
   end;
   with graphe.voie[voieF] do
        valeurCourante := 1/NbrePointsPeriode/incX;
end end; // CherchePeriode

var exposant,mantisse,coeff : extended;
begin // litFrequence
try
{$IFDEF Debug}
      append(FormMain.fichierDebug);
      writeln(FormMain.fichierDebug,'Bode : litFrequence');
      flush(FormMain.fichierDebug);
      closeFile(FormMain.fichierDebug);
{$ENDIF}
      result := cherchePeriode;
      if result then with graphe.voie[voieF] do begin
            if valeurCourante<mini then begin
               exposant := intMaths(log10(abs(valeurCourante)));
               coeff := power(10,exposant);
               mantisse := int(abs(valeurCourante)/coeff);
               mini := mantisse*coeff;
               modifGamme := true;
            end;
            if valeurCourante>maxi then begin
               exposant := intMaths(log10(abs(valeurCourante)));
               coeff := power(10,exposant);
               mantisse := int(abs(valeurCourante)/coeff);
               maxi := (mantisse+1)*coeff;
               modifGamme := true;
            end;
       end;
 //      else showMessage('Impossible de dterminer la frquence');
except
    result := false;
end
end; // litFrequence

var v : indiceVoie;
    x,y : integer;
begin with graphe do begin
     ModifGamme := false;
     voieRef := NumvoieRG.ItemIndex+1;
     for v := voieF to derniereVoie do
         voie[v].NumVoie := voieRef;
{$IFDEF Debug}
      append(FormMain.fichierDebug);
      writeln(FormMain.fichierDebug,'Bode : Lecture Courbes');
      flush(FormMain.fichierDebug);
      closeFile(FormMain.fichierDebug);
{$ENDIF}
     LitCourbes;
     if not(deuxVoiesActives) then exit;
     if not(LitFrequence) then exit;
{$IFDEF Debug}
      append(FormMain.fichierDebug);
      writeln(FormMain.fichierDebug,'Bode : calculGainPhase');
      flush(FormMain.fichierDebug);
      closeFile(FormMain.fichierDebug);
{$ENDIF}
     calculGainPhase;
     if ModifGamme then Oscillo.Invalidate;
     canvas.brush.style := bsSolid;
     for v := voieF to derniereVoie do with voie[v] do begin
          LabelVoie.caption := AffVoltmetre;
          valeur[NbrePoints] := valeurCourante;
          valeurAff := valeurCourante;
          if v<>voieF then begin
             x := voie[voieF].GrandeurToEcran(voie[voieF].valeurCourante);
             y := grandeurToEcran(valeurCourante);
             Canvas.Pen.color := couleur;
             Canvas.Brush.color := couleur;
             Canvas.Rectangle(x-dimPoint,y-dimPoint,x+dimPoint,y+dimPoint);
          end;
     end;
     inc(NbrePoints);
     NonSauve := true;
     setBoutonAcq;
end end; // EnregistreBtnClick 

procedure TBodeForm.RegNewFileClick(Sender: TObject);
begin
     FormDDE.EnvoieDonneesMultimetre(true,true,graphe,
           'Diagramme de Bode avec '+FormMain.identiteScope)
end;

procedure TBodeForm.FormDestroy(Sender: TObject);

procedure SauveConfig;
const titre='Bode';
var Ini : TMemIniFile;
begin with graphe do begin
      try
      Ini := TMemIniFile.Create(NomFichierIni);
      with voie[voieF] do begin
          Ini.WriteFloat(Titre,'MaxiF',Maxi);
          Ini.WriteFloat(Titre,'MiniF',Mini);
          Ini.WriteBool(Titre,'LogX',axeLog);
      end;
      with voie[voieGain] do begin
          Ini.WriteFloat(Titre,'MaxiGain',Maxi);
          Ini.WriteFloat(Titre,'MiniGain',Mini);          
          Ini.WriteInteger(Titre,'couleurG',Couleur);
          Ini.WriteBool(Titre,'logY',axedB);
      end;
      with voie[voiePhase] do begin
          Ini.WriteInteger(Titre,'couleurP',Couleur);
          Ini.WriteBool(Titre,'Degre',enDegre);
          Ini.WriteFloat(Titre,'MaxiPhase',Maxi);
          Ini.WriteFloat(Titre,'MiniPhase',Mini);
      end;
      Ini.WriteInteger(Titre,'Ref',VoieRef);
      Ini.UpdateFile;
      Ini.Free;
      except
      end;
end end;

var v : indiceVoie;
begin
     SauveConfig;
     for v := voieT to voieMax do voieOsc[v].free;
     Graphe.Free;
     BodeForm := nil;
end;

procedure TBodeForm.AddDataBtnClick(Sender: TObject);
begin
     FormDDE.AjouteDonneesMultimetre(graphe)
end;

procedure TBodeForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
     if (key=' ') and enregistreBtn.enabled then begin
         enregistreBtnClick(sender);
         key := #0;
     end;
end;

procedure TBodeForm.ExitBtnClick(Sender: TObject);
begin
     close
end;

Procedure TvoieOsc.Calcul(Nbre : integer);
var i : integer;
    x,sommeEff,sommeDC : extended;
begin
    SommeEff := 0;
    SommeDC := 0;
    for i := 0 to pred(Nbre) do begin
        x := valeur[i];
        SommeEff := SommeEff+sqr(x);
        SommeDC := SommeDC+x;
    end;
    valeurDC := SommeDC/Nbre;
    valeurEff := sqrt(SommeEff/Nbre-sqr(valeurDC));
// pour calcul direct plus rapide dans la dtermination de la phase
end;

procedure TBodeForm.GainClick(Sender: TObject);
begin
     if VoieGainDlg=nil then
         Application.CreateForm(TVoieGainDlg, VoieGainDlg);
     if VoieGainDlg.ShowModal=mrOK then begin
        with graphe.voie[voieGain] do
             LabelVoie.color := couleur;
        Oscillo.invalidate;
        setBoutonAcq;
     end;
end;

procedure TBodeForm.PhaseClick(Sender: TObject);
begin
     if VoiePhaseDlg=nil then
        Application.CreateForm(TVoiePhaseDlg, VoiePhaseDlg);
     if VoiePhaseDlg.ShowModal=mrOK then begin
        with graphe.voie[voiePhase] do begin
             if enDegre then unite := '' else unite := 'rad';
             LabelVoie.color := couleur;
        end;
        Oscillo.invalidate;
        setBoutonAcq;
     end;
end;

end.


