unit Curve;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, sysUtils, Messages,
  clipBrd, spin, Gauges, math, variants, tvcLib_TLB,
  system.Types,
  jmmUtil, Tds200DDE, Main, OscConst, ComCtrls, graphe;

type
  TOscilloForm = class(TForm)
    SaveDialog: TSaveDialog;
    BoutonsPanel: TPanel;
    FileSaveBtn: TSpeedButton;
    ClipSaveBtn: TSpeedButton;
    RegSaveBtn: TSpeedButton;
    EnregistreBtn: TSpeedButton;
    GroupBox1: TGroupBox;
    EditNomB: TEdit;
    Label1: TLabel;
    EditCommB: TEdit;
    Label2: TLabel;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    EditNomA: TEdit;
    EditCommA: TEdit;
    Label7: TLabel;
    XYBtn: TCheckBox;
    ExitBtn: TSpeedButton;
    StatusBar1: TStatusBar;
    PaintBox1: TPaintBox;
    ProgressBar1: TProgressBar;
    Timer: TTimer;
    procedure ExitItemClick(Sender: TObject);
    procedure SaveItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EnregistreBtnClick(Sender: TObject);
    procedure RegSaveBtnClick(Sender: TObject);
    procedure ClipSaveBtnClick(Sender: TObject);
    procedure SaveData(const NomFichier : String);
    procedure EditNomChange(Sender: TObject);
    procedure EditCommChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure RegNewFileClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ExitBtnClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure PaintBox1Paint(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
  private
    Procedure SetBoutonAcq(Permis : boolean);
    procedure LitVoieOsc(Avoie : indiceVoie);
  public
    grapheOsc : TgrapheOsc;
  protected
    procedure WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo); message wm_GetMinMaxInfo;
  end;

var
  OscilloForm: TOscilloForm;

implementation

{$R *.DFM}

procedure TOscilloForm.ExitItemClick(Sender: TObject);
begin
    Close
end;

procedure TOscilloForm.SaveItemClick(Sender: TObject);
begin
     if SaveDialog.Execute then SaveData(saveDialog.FileName)
end;

procedure TOscilloForm.FormCreate(Sender: TObject);
begin
  grapheOsc := TgrapheOsc.Create;
  grapheOsc.Canvas := paintBox1.canvas;
end;

procedure TOscilloForm.LitVoieOsc(Avoie : indiceVoie);
var xinc : Double;
begin with grapheOsc do begin
   statusBar1.SimpleText := 'Lecture de CH'+intTostr(avoie)+' : attendre !';
   FormMain.LitVoie(Avoie,voie[avoie].valeur,voie[voieT].valeur,
      voie[avoie].mini,voie[avoie].maxi,nbrePoints,xinc);
   statusBar1.simpleText := 'Lecture de CH'+intTostr(avoie)+' termine';
end end;

procedure TOscilloForm.PaintBox1Paint(Sender: TObject);
begin
     GrapheOsc.DrawG(PaintBox1.clientRect)
end;

procedure TOscilloForm.EnregistreBtnClick(Sender: TObject);
var v : indiceVoie;
begin
{$IFDEF Debug}
      append(FormMain.fichierDebug);
      writeln(FormMain.fichierDebug,'EnregistreBtnClick');
      flush(FormMain.fichierDebug);
      closeFile(FormMain.fichierDebug);
{$ENDIF}
     timer.enabled := true;
     progressBar1.Position := 0;
     statusBar1.SimpleText := 'Lecture en cours : attendre !';
     grapheOsc.nbrePoints := 0;
     cursor := crHourGlass;
     setBoutonAcq(false);
     try
     for v := voieA to voieB do begin
        grapheOsc.voie[v].active := FormMain.active(v);
{$IFDEF Debug}
      append(FormMain.fichierDebug);
      writeln(FormMain.fichierDebug,intToStr(v)+'='+BoolToStr(grapheOsc.voie[v].active));
      flush(FormMain.fichierDebug);
      closeFile(FormMain.fichierDebug);
{$ENDIF}
        if grapheOsc.voie[v].active then LitVoieOsc(v);
     end;
     setBoutonAcq(true);
{$IFDEF Debug}
      append(FormMain.fichierDebug);
      writeln(FormMain.fichierDebug,'appel paintbox');
      flush(FormMain.fichierDebug);
      closeFile(FormMain.fichierDebug);
{$ENDIF}
     paintBox1.invalidate;
     statusBar1.SimpleText := 'Lecture termine';
{$IFDEF Debug}
      append(FormMain.fichierDebug);
      writeln(FormMain.fichierDebug,'Lecture termine');
      flush(FormMain.fichierDebug);
      closeFile(FormMain.fichierDebug);
{$ENDIF}
     except
        setBoutonAcq(true);
        statusBar1.SimpleText := 'Erreur de lecture';
{$IFDEF Debug}
        append(FormMain.fichierDebug);
        writeln(FormMain.fichierDebug,'Erreur de lecture');
        flush(FormMain.fichierDebug);
        closeFile(FormMain.fichierDebug);
{$ENDIF}
     end;
     cursor := crDefault;
     timer.enabled := false;
end;

procedure TOscilloForm.RegSaveBtnClick(Sender: TObject);
begin
     if ConstanteDlg.showModal=mrOk then begin
        FormDDE.EnvoieDonneesOscillo(true,XYBtn.checked);
     end;
end;

procedure TOscilloForm.ClipSaveBtnClick(Sender: TObject);
begin
     FormDDE.EnvoieDonneesOscillo(false,XYBtn.checked);
end;

procedure TOscilloForm.SetBoutonAcq(permis : boolean);
begin
     FileSaveBtn.Visible := permis;
     ClipSaveBtn.Visible := permis;
     RegSaveBtn.Visible := permis;
     FileSaveBtn.enabled := grapheOsc.nbrePoints>0;
     ClipSaveBtn.enabled := FileSaveBtn.enabled;
     RegSaveBtn.enabled := FileSaveBtn.enabled;
     if permis
        then screen.cursor := crDefault
        else screen.cursor := crHourGlass;
end;

procedure TOscilloForm.TimerTimer(Sender: TObject);
begin
     if progressBar1.Position<progressBar1.Max
       then progressBar1.Position := progressBar1.Position+1
       else progressBar1.Position := 0;
end;

procedure TOscilloForm.SaveData(const NomFichier : String);
var fichier : textFile;
    formatRW3 : boolean;

Procedure EcritPage;
var j : indiceVecteur;
    v : indiceVoie;
begin if formatRW3
  then begin
     writeln(fichier,SymbReg,'1 PAGE COMMENT');
     writeln(fichier,'');
     writeln(fichier,SymbReg2,grapheOsc.NbrePoints,' VALEUR VAR');
     for j := 1 to grapheOsc.NbrePoints do begin
         for v := voieT to voieMax do with grapheOsc.voie[v] do if active then
             write(fichier,FloatToStrPoint(valeur[j]),' ');
         writeln(fichier);
     end
 end
 else begin
    for j := 1 to grapheOsc.NbrePoints do begin
        for v := voieT to voieMax do with grapheOsc.voie[v] do
            if active then
               write(fichier,FloatToStrPoint(valeur[j]),crTab);
        writeln(fichier);
    end;
end
end; // ecritPage

Procedure ecritEnTete;
var j : indiceVoie;
    NbreVoies : integer;
begin if formatRW3
then with grapheOsc do begin
   NbreVoies := 0;
   for j := voieT to voieMax do
       if grapheOsc.voie[j].active then inc(NbreVoies);
   writeln(fichier,'EVARISTE REGRESSI WINDOWS 1.0');
   writeln(fichier,symbReg,NbreVoies,' NOM VAR');
   for j := voieT to voieMax do if voie[j].active then
       writeln(fichier,voie[j].nom);
   writeln(fichier,symbReg,NbreVoies,' UNITE VAR');
   for j := voieT to VoieMax do if voie[j].active then
      writeln(fichier,voie[j].unite);
   writeln(fichier,symbReg,NbreVoies,' SIGNIF VAR');
   for j := voieT to VoieMax do if voie[j].active then
      writeln(fichier,voie[j].signif);
   writeln(fichier,symbReg,'1 ACQUISITION');
   writeln(fichier,Application.ExeName)
end
else with grapheOsc do begin
   writeln(fichier,formMain.nomScope);
   for j := voieT to VoieMax do if voie[j].active then
      write(fichier,voie[j].nom,crTab);
   writeln(fichier);
   for j := voieT to VoieMax do if voie[j].active then
      write(fichier,voie[j].unite,crTab);
   writeln(fichier);
   for j := voieT to VoieMax do if voie[j].active then
      write(fichier,voie[j].signif,crTab);
   writeln(fichier);
end
end; // ecritEnTete

begin
    Screen.Cursor := crHourGlass;
    FormatRW3 := AnsiUpperCase(ExtractFileExt(NomFichier))='.RW3';
    AssignFile(fichier,NomFichier);
    Rewrite(fichier);
    ecritEnTete;
    ecritPage;
    CloseFile(fichier);
    Screen.Cursor := crDefault;
end;

procedure TOscilloForm.EditNomChange(Sender: TObject);
var NumVoie : indiceVoie;
begin
     NumVoie := (sender as Tcomponent).tag;
     grapheOsc.voie[NumVoie].nom := (sender as Tedit).text;
end;

procedure TOscilloForm.EditCommChange(Sender: TObject);
var NumVoie : indiceVoie;
begin
     NumVoie := (sender as Tcomponent).tag;
     grapheOsc.voie[NumVoie].signif := (sender as Tedit).text;
end;

procedure TOscilloForm.FormActivate(Sender: TObject);
begin
     setBoutonAcq(true)
end;

procedure TOscilloForm.RegNewFileClick(Sender: TObject);
begin
     FormDDE.EnvoieDonneesOscillo(true,XYBtn.checked)
end;

procedure TOscilloForm.FormDestroy(Sender: TObject);
begin
     grapheOsc.free;
     OscilloForm := nil
end;

procedure TOscilloForm.WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo);
begin
     with Msg.MinMaxInfo^ do begin
          ptMinTrackSize := point(720,480);
          ptMaxTrackSize := point(screen.width-20,480);
     end;
end;

procedure TOscilloForm.FormResize(Sender: TObject);
begin
     EditCommA.width := GroupBox1.width-EditCommA.left-12;
     EditCommB.width := GroupBox2.width-EditCommB.left-12;
end;

procedure TOscilloForm.FormClose(Sender: TObject;var Action: TCloseAction);
begin
  FormMain.setMode(mNone);
  Action := caFree;
end;

procedure TOscilloForm.ExitBtnClick(Sender: TObject);
begin
  close
end;

procedure TOscilloForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
     if (key=' ') and enregistreBtn.visible then begin
         enregistreBtnClick(sender);
         key := #0;
     end;
end;

end.

