unit CurveMaths;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, sysUtils, Messages,
  clipBrd, spin, Gauges, math, variants, tvcLib_TLB,
  system.UITypes, system.Types,
  jmmUtil, Tds200DDE, Main, OscConst, ComCtrls, graphe;

type
  TMathsForm = class(TForm)
    SaveDialog: TSaveDialog;
    BoutonsPanel: TPanel;
    FileSaveBtn: TSpeedButton;
    ClipSaveBtn: TSpeedButton;
    RegSaveBtn: TSpeedButton;
    EnregistreBtn: TSpeedButton;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    EditNomA: TEdit;
    EditCommA: TEdit;
    Label7: TLabel;
    ExitBtn: TSpeedButton;
    StatusBar: TStatusBar;
    ProgressBar1: TProgressBar;
    Timer: TTimer;
    procedure ExitItemClick(Sender: TObject);
    procedure SaveItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EnregistreBtnClick(Sender: TObject);
    procedure RegSaveBtnClick(Sender: TObject);
    procedure ClipSaveBtnClick(Sender: TObject);
    procedure SaveData(const NomFichier : String);
    procedure EditNomChange(Sender: TObject);
    procedure EditCommChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure RegNewFileClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ExitBtnClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure TimerTimer(Sender: TObject);
  private
    Procedure SetBoutonAcq(Permis : boolean);
    procedure LitVoieMaths;
  public
    grapheOsc : TgrapheOsc;
  protected
    procedure WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo); message wm_GetMinMaxInfo;
  end;

var
  MathsForm: TMathsForm;

implementation

{$R *.DFM}

procedure TMathsForm.ExitItemClick(Sender: TObject);
begin
    Close
end;

procedure TMathsForm.SaveItemClick(Sender: TObject);
begin
     if SaveDialog.Execute then SaveData(saveDialog.FileName)
end;

procedure TMathsForm.FormCreate(Sender: TObject);
begin
  grapheOsc := TgrapheOsc.Create;
end;

procedure TMathsForm.LitVoieMaths;
var
 xinc : Double;
begin with grapheOsc do begin
   statusBar.SimpleText := 'Lecture de voie Maths : attendre !';
   FormMain.LitVoieMaths(voie[voieA].valeur,voie[voieT].valeur,
      voie[voieT].unite,voie[voieA].unite,
      nbrePoints,xinc);
   statusBar.simpleText := 'Lecture de voie Maths termine';
end end;

procedure TMathsForm.EnregistreBtnClick(Sender: TObject);
var reponse : string;
    voieMathsActive : boolean;
begin
     timer.enabled := true;
     progressBar1.Position := 0;
     statusBar.SimpleText := 'Lecture en cours : attendre !';
     grapheOsc.nbrePoints := 0;
     try
     cursor := crHourGlass;
     setBoutonAcq(false);
     reponse := FormMain.GetString('SEL:MATH?');
     voieMathsActive := (pos('ON',reponse)>0) or (pos('1',reponse)>0);
     if voieMathsActive
        then LitVoieMaths
        else begin
           grapheOsc.NbrePoints := 0;
           showMessage('voie Maths non active')
        end;
     setBoutonAcq(true);
{$IFDEF Debug}
      append(FormMain.fichierDebug);
      writeln(FormMain.fichierDebug,'appel paintbox');
      flush(FormMain.fichierDebug);
      closeFile(FormMain.fichierDebug);
{$ENDIF}
     statusBar.SimpleText := 'Lecture termine';
{$IFDEF Debug}
      append(FormMain.fichierDebug);
      writeln(FormMain.fichierDebug,'Lecture termine');
      flush(FormMain.fichierDebug);
      closeFile(FormMain.fichierDebug);
{$ENDIF}
     except
        setBoutonAcq(true);
        statusBar.SimpleText := 'Erreur de lecture';
{$IFDEF Debug}
        append(FormMain.fichierDebug);
        writeln(FormMain.fichierDebug,'Erreur de lecture');
        flush(FormMain.fichierDebug);
        closeFile(FormMain.fichierDebug);
{$ENDIF}
     end;
     cursor := crDefault;
     timer.enabled := false;
end;

procedure TMathsForm.RegSaveBtnClick(Sender: TObject);
begin
     if ConstanteDlg.showModal=mrOk then
        FormDDE.EnvoieDonneesMaths(true);
end;

procedure TMathsForm.ClipSaveBtnClick(Sender: TObject);
begin
     FormDDE.EnvoieDonneesMaths(false);
end;

procedure TMathsForm.SetBoutonAcq(permis : boolean);
begin
     FileSaveBtn.Visible := permis;
     ClipSaveBtn.Visible := permis;
     RegSaveBtn.Visible := permis;
     FileSaveBtn.enabled := grapheOsc.nbrePoints>0;
     ClipSaveBtn.enabled := FileSaveBtn.enabled;
     RegSaveBtn.enabled := FileSaveBtn.enabled;
     if permis
        then screen.cursor := crDefault
        else screen.cursor := crHourGlass;
end;

procedure TMathsForm.TimerTimer(Sender: TObject);
begin
     if progressBar1.Position<progressBar1.Max
       then progressBar1.Position := progressBar1.Position+1
       else progressBar1.Position := 0;
end;

procedure TMathsForm.SaveData(const NomFichier : String);
var fichier : textFile;
    formatRW3 : boolean;

Procedure EcritPage;
var j : indiceVecteur;
    v : indiceVoie;
begin if formatRW3
  then begin
     writeln(fichier,SymbReg,'1 PAGE COMMENT');
     writeln(fichier,'');
     writeln(fichier,SymbReg2,grapheOsc.NbrePoints,' VALEUR VAR');
     for j := 1 to grapheOsc.NbrePoints do begin
         for v := voieT to voieA do with grapheOsc.voie[v] do
             write(fichier,FloatToStrPoint(valeur[j]),' ');
         writeln(fichier);
     end
 end
 else begin
    for j := 1 to grapheOsc.NbrePoints do begin
        for v := voieT to voieA do with grapheOsc.voie[v] do
               write(fichier,FloatToStrPoint(valeur[j]),crTab);
        writeln(fichier);
    end;
end
end; // ecritPage

Procedure ecritEnTete;
var j : indiceVoie;
begin if formatRW3
then with grapheOsc do begin
   writeln(fichier,'EVARISTE REGRESSI WINDOWS 1.0');
   writeln(fichier,symbReg,2,' NOM VAR');
   for j := voieT to voieA do
       writeln(fichier,voie[j].nom);
   writeln(fichier,symbReg,2,' UNITE VAR');
   for j := voieT to VoieA do
      writeln(fichier,voie[j].unite);
   writeln(fichier,symbReg,2,' SIGNIF VAR');
   for j := voieT to VoieA do
      writeln(fichier,voie[j].signif);
   writeln(fichier,symbReg,'1 ACQUISITION');
   writeln(fichier,Application.ExeName)
end
else with grapheOsc do begin
   writeln(fichier,formMain.nomScope);
   for j := voieT to VoieA do
      write(fichier,voie[j].nom,crTab);
   writeln(fichier);
   for j := voieT to VoieA do
      write(fichier,voie[j].unite,crTab);
   writeln(fichier);
   for j := voieT to VoieA do
      write(fichier,voie[j].signif,crTab);
   writeln(fichier);
end
end; // ecritEnTete

begin
    Screen.Cursor := crHourGlass;
    FormatRW3 := AnsiUpperCase(ExtractFileExt(NomFichier))='.RW3';
    AssignFile(fichier,NomFichier);
    Rewrite(fichier);
    ecritEnTete;
    ecritPage;
    CloseFile(fichier);
    Screen.Cursor := crDefault;
end;

procedure TMathsForm.EditNomChange(Sender: TObject);
var NumVoie : indiceVoie;
begin
     NumVoie := (sender as Tcomponent).tag;
     grapheOsc.voie[NumVoie].nom := (sender as Tedit).text;
end;

procedure TMathsForm.EditCommChange(Sender: TObject);
var NumVoie : indiceVoie;
begin
     NumVoie := (sender as Tcomponent).tag;
     grapheOsc.voie[NumVoie].signif := (sender as Tedit).text;
end;

procedure TMathsForm.FormActivate(Sender: TObject);
begin
     setBoutonAcq(true)
end;

procedure TMathsForm.RegNewFileClick(Sender: TObject);
begin
     FormDDE.EnvoieDonneesMaths(true)
end;

procedure TMathsForm.FormDestroy(Sender: TObject);
begin
     grapheOsc.free;
     MathsForm := nil
end;

procedure TMathsForm.WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo);
begin
     with Msg.MinMaxInfo^ do begin
          ptMinTrackSize := point(720,480);
          ptMaxTrackSize := point(screen.width-20,480);
     end;
end;

procedure TMathsForm.FormResize(Sender: TObject);
begin
     EditCommA.width := GroupBox2.width-EditCommA.left-12;
end;

procedure TMathsForm.FormClose(Sender: TObject;var Action: TCloseAction);
begin
  FormMain.setMode(mNone);
  Action := caFree;
end;

procedure TMathsForm.ExitBtnClick(Sender: TObject);
begin
  close
end;

procedure TMathsForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
     if (key=' ') and enregistreBtn.visible then begin
         enregistreBtnClick(sender);
         key := #0;
     end;
end;

end.


