unit Voiefreq;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, SysUtils,
  jmmUtil, graphe, math;

type
  TVoieXDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Bevel1: TBevel;
    GroupBox5: TGroupBox;
    GroupBox2: TGroupBox;
    EditMaxi: TEdit;
    MaxiSpin: TSpinButton;
    GroupBox1: TGroupBox;
    EditMini: TEdit;
    MiniSpin: TSpinButton;
    GroupBox3: TGroupBox;
    logCB: TCheckBox;
    NumVoieRG: TRadioGroup;
    Memo1: TMemo;
    procedure MaxiSpinDownClick(Sender: TObject);
    procedure MaxiSpinUpClick(Sender: TObject);
    procedure MiniSpinUpClick(Sender: TObject);
    procedure MiniSpinDownClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
    function StrFrequence(var valeur : double) : String;
  public
     voieLue : Tvoie;
  end;

var
  VoieXDlg: TVoieXDlg;

implementation

{$R *.DFM}

function TVoieXDlg.StrFrequence(var valeur : double) : String;
var exposant,mantisse,coeff : double;
begin
     exposant := intMaths(log10(abs(valeur)));
     coeff := power(10,exposant);
     mantisse := int(abs(valeur)/coeff);
     if mantisse>2
        then if mantisse<6
             then mantisse := 5
             else mantisse := 10;
     valeur := mantisse*coeff;
     if valeur<1
        then StrFrequence := IntToStr(round(valeur*1000))+' mHz'
        else if valeur<1000
           then StrFrequence := IntToStr(round(valeur))+' Hz'
           else if valeur<1e6
               then StrFrequence := IntToStr(round(valeur/1000))+' kHz'
               else StrFrequence := IntToStr(round(valeur/1e6))+' MHz'
end;

procedure TVoieXDlg.MaxiSpinDownClick(Sender: TObject);
begin with voieLue do begin
     if maxi>=20*mini
        then maxi := maxi/2
        else Erreur('Maxi trop proche du mini');
     EditMaxi.text := StrFrequence(maxi);
end end;

procedure TVoieXDlg.MaxiSpinUpClick(Sender: TObject);
begin with voieLue do begin
     if maxi<=1e6
        then maxi := maxi*2
        else Erreur('Maxi < 1 MHz');
     EditMaxi.text := StrFrequence(maxi);
end end;

procedure TVoieXDlg.MiniSpinUpClick(Sender: TObject);
begin with voieLue do begin
     if mini<=maxi/20
        then mini := mini*2
        else Erreur('Mini trop proche du maxi');
     EditMini.text := StrFrequence(mini);
end end;

procedure TVoieXDlg.MiniSpinDownClick(Sender: TObject);
begin with voieLue do begin
     if mini>=0.1
        then mini := mini/2
        else Erreur('Mini = 0,1 Hz');
     EditMini.text := StrFrequence(mini);
end end;

procedure TVoieXDlg.FormActivate(Sender: TObject);
begin with voieLue do begin
     try
     EditMini.text := StrFrequence(mini);
     except
         EditMini.text := '10 Hz';
         mini := 10;
     end;
     try
     EditMaxi.text := StrFrequence(maxi);
     except
         maxi := 10000;
         EditMaxi.text := '10 kHz';
     end;
     NumVoieRG.itemIndex := pred(NumVoie);
     logCB.checked := AxeLog;
end end;

procedure TVoieXDlg.OKBtnClick(Sender: TObject);
begin with voieLue do begin
     NumVoie := succ(NumVoieRG.itemIndex);
     AxeLog := logCB.checked;
end end;

end.
