unit Voies;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, SysUtils, dialogs, inifiles,
  jmmUtil, Graphe;

type
  TVoiesDlg = class(TForm)
    ActiveBtn: TBitBtn;
    CancelBtn: TBitBtn;
    ListeCommande: TListBox;
    NumVoieRG: TRadioGroup;
    GroupBox2: TGroupBox;
    EditMaxi: TEdit;
    Bevel1: TBevel;
    UniteLabel: TLabel;
    GroupBox3: TGroupBox;
    EditNom: TEdit;
    GroupBox1: TGroupBox;
    EditComm: TEdit;
    DesactiveBtn: TBitBtn;
    procedure ActiveBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ListeCommandeClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    ListeVoieTDS : Tlist;
    ModifNom : boolean;
  public
    VoieLue : Tvoie;
  end;

var
  VoiesDlg: TVoiesDlg;

implementation

{$R *.DFM}

procedure TVoiesDlg.ActiveBtnClick(Sender: TObject);
var voieTDS : TvoieTDS;
begin
     voieLue.Active := sender=ActiveBtn;
     voieLue.NumVoie := succ(NumVoieRG.itemIndex);
     if ListeCommande.itemIndex>=0 then begin
        voieTDS := Tvoie(ListeVoieTDS[ListeCommande.itemIndex]);
        voieLue.Command := voieTDS.Command;
        voieLue.Signif := voieTDS.Signif;
        voieLue.Unite := voieTDS.Unite;
        voieLue.positive := voieTDS.positive;
        voieLue.CalculIncertitude := voieTDS.CalculIncertitude;
     end;
     voieLue.Nom := EditNom.text;
     voieLue.Commentaire := EditComm.text;
     try
     voieLue.Maxi := StrToFloatWin(EditMaxi.text);
     except
     end;
     if voieLue.Positive
        then voieLue.Mini := 0
        else voieLue.Mini := -voieLue.Maxi
end;

procedure TVoiesDlg.FormCreate(Sender: TObject);
var ini : Tinifile;
    VoieTDS : TvoieTDS;
    NomFichier,NomIndex : String;
    i : integer;
begin
        ListeVoieTDS := Tlist.Create;
        ListeCommande.clear;
        Ini := TiniFile.Create(NomFichierIni);
        Ini.ReadSections(ListeCommande.items);
        if ListeCommande.items.count=0 then begin
           showMessage('Impossible : '+NomFichier+' endommag');
           ini.free;
           halt;
        end;
        for i := 0 to pred(ListeCommande.items.count) do begin
           voieTDS := TvoieTDS.Create;
           NomIndex := ListeCommande.items[i];
           with voieTDS do begin
             Nom := Ini.ReadString(NomIndex,'Nom','');
             Unite := Ini.ReadString(NomIndex,'Unite','');
             Command := Ini.ReadString(NomIndex,'Command','');
             Signif := Ini.ReadString(NomIndex,'Signif','');
             Positive := Ini.ReadBool(NomIndex,'Positive',true);
             CalculIncertitude := TcalculIncertitude(Ini.ReadInteger(NomIndex,'Incertitude',0));
             Maxi := Ini.ReadFloat(NomIndex,'Maxi',maxi);
             If positive then mini := 0 else mini := -maxi;
             listeVoieTDS.Add(voieTDS);
             ListeCommande.items[i] := signif;
         end;
       end;
       Ini.Free;
end;

procedure TVoiesDlg.FormActivate(Sender: TObject);
begin with voieLue do begin
     NumVoieRG.itemIndex := pred(numVoie);
     ModifNom := false;
     ListeCommande.ItemIndex := ListeCommande.items.indexOf(signif);
     if ListeCommande.ItemIndex<0 then ListeCommande.itemIndex := 1;
     ModifNom := true;
     EditMaxi.text := FloatToStr(Maxi);
     EditNom.text := nom;
     EditComm.text := commentaire;
     UniteLabel.caption := unite;
end end;

procedure TVoiesDlg.ListeCommandeClick(Sender: TObject);
var voieTDS : TvoieTDS;
begin
     voieTDS := TvoieTDS(ListeVoieTDS[ListeCommande.itemIndex]);
     UniteLabel.caption := voieTDS.Unite;
     if ModifNom then begin
        EditNom.text := voieTDS.Nom;
        if (EditNom.text<>'f')
            then EditNom.text := EditNom.text + IntToStr(succ(NumVoieRG.ItemIndex));
        EditMaxi.text := FloatToStr(voieTDS.Maxi);
     end;
end;

procedure TVoiesDlg.FormDestroy(Sender: TObject);
begin
       ListeVoieTDS.Clear;
       ListeVoieTDS.Free
end;

end.
